package redis_client

import (
	"code.gitea.io/gitea/modules/labelmsg"
	"fmt"
	"github.com/gomodule/redigo/redis"
	"math"
	"strconv"
	"time"
)

//todo redis连接池
func Setex(key, value string, timeout time.Duration) (bool, error) {
	redisClient := labelmsg.Get()
	defer redisClient.Close()

	seconds := int(math.Floor(timeout.Seconds()))
	reply, err := redisClient.Do("SETEX", key, seconds, value)
	if err != nil {
		return false, err
	}
	if reply != "OK" {
		return false, nil
	}
	return true, nil

}

func Get(key string) (string, error) {
	redisClient := labelmsg.Get()
	defer redisClient.Close()

	reply, err := redisClient.Do("GET", key)
	if err != nil {
		return "", err
	}
	if reply == nil {
		return "", err
	}
	s, _ := redis.String(reply, nil)
	return s, nil

}

func Del(key string) (int, error) {
	redisClient := labelmsg.Get()
	defer redisClient.Close()

	reply, err := redisClient.Do("DEL", key)
	if err != nil {
		return 0, err
	}
	if reply == nil {
		return 0, err
	}
	s, _ := redis.Int(reply, nil)
	return s, nil

}

func TTL(key string) (int, error) {
	redisClient := labelmsg.Get()
	defer redisClient.Close()

	reply, err := redisClient.Do("TTL", key)
	if err != nil {
		return 0, err
	}
	n, _ := strconv.Atoi(fmt.Sprint(reply))
	return n, nil

}
