package authentication

import (
	"code.gitea.io/gitea/modules/auth/wechat"
	"code.gitea.io/gitea/modules/context"
	"code.gitea.io/gitea/modules/log"
	"encoding/xml"
	"io/ioutil"
	"time"
)

// AcceptWechatEvent
func AcceptWechatEvent(ctx *context.Context) {
	b, _ := ioutil.ReadAll(ctx.Req.Request.Body)
	we := wechat.WechatEvent{}
	xml.Unmarshal(b, &we)

	log.Info("accept wechat event= %+v", we)
	var replyStr string
	if we.Event == "subscribe" {
		replyStr = wechat.HandleSubscribeEvent(we)
	}

	if replyStr == "" {
		log.Info("reply str is empty")
		return
	}
	reply := &wechat.EventReply{
		ToUserName:   we.FromUserName,
		FromUserName: we.ToUserName,
		CreateTime:   time.Now().Unix(),
		MsgType:      "text",
		Content:      replyStr,
	}
	ctx.XML(200, reply)
}

// ValidEventSource
func ValidEventSource(ctx *context.Context) {
	echostr := ctx.Query("echostr")
	ctx.Write([]byte(echostr))
	return
}
